﻿namespace TestProject;

/// <summary>
/// 항목 동일성 비교자
/// </summary>
public class ItemEqualityComparer : IEqualityComparer<Item>
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 해시 코드 구하기 - GetHashCode(item)

    /// <summary>
    /// 해시 코드 구하기
    /// </summary>
    /// <param name="item">항목</param>
    /// <returns>해시 코드</returns>
    public int GetHashCode(Item item)
    {
        return item.ID.GetHashCode()   ^
               item.Name.GetHashCode() ^
               item.Code.GetHashCode() ^
               item.Price.GetHashCode();
    }

    #endregion
    #region 동일 여부 구하기 - Equals(item1, item2)

    /// <summary>
    /// 동일 여부 구하기
    /// </summary>
    /// <param name="item1">항목 1</param>
    /// <param name="item2">항목 2</param>
    /// <returns>동일 여부</returns>
    public bool Equals(Item item1, Item item2)
    {
        return item1.ID    == item2.ID   &&
               item1.Name  == item2.Name &&
               item1.Code  == item2.Code &&
               item1.Price == item2.Price;
    }

    #endregion
}